.INCLUDE     "1200def.inc"
;==============================================================
;    AT90S1200
; 5    
;==============================================================
.ORG 000                                      ; 
                    rjmp reset   
 
.ORG 002                                      ;    
                   inc r27                         ;    r27
                   sbrc r27,0                   ;     r27
                   rjmp pause                 ;   
                   sbrs r27,0                   ;     r27
                   rjmp impulse              ;    
pause:
                   cbi portb,3                ;   PB3  0
                   out tcnt0,r28             ;    1
                   rjmp exit_timer         ;    
impulse:
                   sbi portb,3                ;   PB3  1
                   out tcnt0,r29             ;    0
                   rjmp exit_timer         ;    
exit_timer:
                   reti                             ;   


reset:
                  ldi r31,$18           ;  
                  out ddrb,r31        ;PB0,PB1,PB2-- , PB3,PB4-- 
                  ldi r28,$99          ;   
                  ldi r29,$66          ;   
                  ldi r31,$17          ;  
                  out portb,r31      ;  PB0,PB1,PB2
                  ldi r31,$01         ;  
                  out tccr0,r31      ;      
                  ldi r31,$02
                  out timsk,r31     ;   
stop:
                  cbi portb,4         ;  PB4     
                  ldi r27,$0           
                  rjmp scan1        ;   
scan1:
                  sbis pinb,0        ;   ON/OFF(PD0)
                  rjmp start           ;   
                  sbis pinb,1        ;   "+"(PD1)
                  rjmp start           ;   
                  sbis pinb,2        ;   "-"(PD2)
                  rjmp start          ;   
                  rjmp scan1        ;         
start:
                  sbi portb,4             ; .1   PB4   
                  sbi portb,3             ; . 1    (PB3)
                  out tcnt0,r29          ;        
                  sei                          ; 
                  rcall pause_scan   ;  
                  rjmp scan2             ;   
scan2:
                  sbis pinb,0             ;   ON/OFF(PD0)
                  rjmp off                    ;      
                  sbis pinb,1              ;   "+"(PD1)
                  rjmp plus                  ;       
                  sbis pinb,2              ;   "-"(PD2)
                  rjmp minus                ;       
                  rjmp scan2               ;         
off:            
                  cli                                ;        
                  cbi portb,3                 ;    (PB3)  . 0
                  rcall pause_scan      ;    
                  rjmp stop                    ;      stop
plus:
                  ldi r26,$ff                     ;                   
                  cpse r26,r28               ;    
                  rjmp plus1                   ;         
                  rjmp scan2                  ;        
minus:
                  ldi r26,$33                   ;   
                  cpse r26,r28                ;    
                  rjmp minus1                 ;         
                  rjmp scan2                   ;         
plus1:
                  ldi r26,$33                    ;            
                  add r28,r26                  ;  
                  sub r29,r26                   ;  
                  rcall pause_scan         ;  
                  rjmp scan2                    ;    
minus1:
                  ldi r26,$33                    ;               
                  add r29,r26                  ;   
                  sub r28,r26                   ;   
                  rcall pause_scan          ;  
                  rjmp scan2                   ;    
;==============================================================
; .                    .
;==============================================================
pause_scan:
                   ldi	r25,3
D100_3:	clr	r24          ; 
D100_2:	clr	r23          ; 
D100_1:	dec	r23          ;     
	brne	D100_1  ;  
	dec            r24          ;     
	brne	D100_2   ;  
	dec	R25          ;     
	brne	D100_3   ;  
	ret                               ;  

.EXIT

